=== Makefile ===
#
# This file is part of the Simutrans project under the Artistic License.
# (see LICENSE.txt)
#

# Define variables here to force them as simple flavor. -> Faster parallel builds.
FLAGS :=
CFLAGS ?=
LDFLAGS ?=
LIBS :=
SOURCES :=
STATIC := 0

DYNAMICSTART =
DYNAMICEND =

CFG ?= default
-include config.$(CFG)


HOSTCC  ?=$(CC)
HOSTCXX ?=$(CXX)

SDL2_CONFIG      ?= pkg-config sdl2
#SDL2_CONFIG     ?= sdl2-config
FREETYPE_CONFIG  ?= pkg-config freetype2
# FREETYPE_CONFIG ?= freetype-config
FONTCONFIG_CONFIG  ?= pkg-config fontconfig

BACKENDS  := gdi sdl2 mixer_sdl2 posix
OSTYPES   := amiga freebsd haiku linux mac mingw openbsd


ifeq ($(findstring $(BACKEND), $(BACKENDS)),)
  $(error Unkown BACKEND "$(BACKEND)", must be one of "$(BACKENDS)")
endif

ifeq ($(findstring $(OSTYPE), $(OSTYPES)),)
  $(error Unkown OSTYPE "$(OSTYPE)", must be one of "$(OSTYPES)")
endif

ifeq ($(BACKEND),posix)
  COLOUR_DEPTH := 0
else
  COLOUR_DEPTH := 16
endif

# since threads are needed to be linked dynamically on most systems
ifdef MULTI_THREAD
  ifeq ($(shell expr $(MULTI_THREAD) \>= 1), 1)
    CFLAGS += -DMULTI_THREAD
    ifneq ($(OSTYPE),mingw)
      ifneq ($(OSTYPE),haiku)
        # mingw has already added pthread statically
        ifneq ($(OSTYPE),mingw)
          LDFLAGS += -lpthread
        endif
      endif
    endif
  else
    ifneq ($(OSTYPE),mingw)
      ifeq ($(BACKEND),sdl2)
        LDFLAGS += -lpthread
      endif
      ifeq ($(BACKEND),mixer_sdl2)
        LDFLAGS += -lpthread
      endif
    endif
  endif
endif

ifeq ($(OSTYPE),amiga)
  STD_LIBS ?= -lunix -lSDL_mixer -lsmpeg -lvorbisfile -lvorbis -logg
  CFLAGS   += -mcrt=newlib -DSIM_BIG_ENDIAN -gstabs+
  LDFLAGS  += -Bstatic -non_shared
else ifeq ($(OSTYPE),beos)
  # BeOS (obsolete)
  LIBS += -lnet
else ifeq ($(OSTYPE),freebsd)
  CFLAGS  += -I/usr/local/include
else ifeq ($(OSTYPE),haiku)
  # Haiku (needs to activate the GCC 4x)
  LIBS += -lnetwork -lbe
else ifeq ($(OSTYPE),mingw)
  CFLAGS    += -DPNG_STATIC -DZLIB_STATIC
  ifeq ($(shell expr $(STATIC) \>= 1), 1)
    CFLAGS  += -static
    LDFLAGS += -static-libgcc -static-libstdc++ -static
  endif
  ifeq ($(MINGW_PACKAGE_PREFIX),mingw-w64-i686)
    LDFLAGS   += -Wl,--large-address-aware
  endif
  LDFLAGS   += -pthread
  CFLAGS    += -Wno-deprecated-copy -DNOMINMAX -DWIN32_LEAN_AND_MEAN -DWINVER=0x0501 -D_WIN32_IE=0x0500
  LIBS      += -lmingw32 -lgdi32 -lwinmm -lws2_32 -limm32

  # Disable the console on Windows unless WIN32_CONSOLE is set or graphics are disabled
  ifdef WIN32_CONSOLE
    ifeq ($(shell expr $(WIN32_CONSOLE) \>= 1), 1)
      LDFLAGS += -mconsole
    endif
  else ifeq ($(BACKEND),posix)
    LDFLAGS += -mconsole
  else
    LDFLAGS += -mwindows
  endif
else ifeq ($(OSTYPE),linux)
  ifeq ($(shell expr $(STATIC) \>= 1), 1)
    LDFLAGS +=  -Wl,-Bstatic -lm
    DYNAMICSTART = -Wl,-Bdynamic 
    DYNAMICEND = -Wl,-Bstatic 
  endif
else ifeq ($(OSTYPE),mac)
  LDFLAGS += -framework Cocoa
endif

ifeq ($(BACKEND),sdl2)
  SOURCES += src/simutrans/sys/clipboard_s2.cc
else ifeq ($(OSTYPE),mingw)
  SOURCES += src/simutrans/sys/clipboard_w32.cc
else
  SOURCES += src/simutrans/sys/clipboard_internal.cc
endif

LIBS += -lbz2 -lz -lpng

ifdef OPTIMISE
  ifeq ($(shell expr $(OPTIMISE) \>= 1), 1)
    CFLAGS += -O3
    ifeq ($(findstring amiga, $(OSTYPE)),)
      ifneq ($(findstring clang, $(CXX)),)
        CFLAGS += -minline-all-stringops
      endif
    endif
  endif
else
  CFLAGS += -O1
endif

ifneq ($(LTO),)
  CFLAGS += -flto
  LDFLAGS += -flto
endif

ifdef DEBUG
  MSG_LEVEL ?= 3
  PROFILE ?= 0

  ifeq ($(shell expr $(DEBUG) \>= 1), 1)
    CFLAGS   += -g -DDEBUG
  endif

  ifeq ($(shell expr $(DEBUG) \>= 2), 1)
    ifeq ($(shell expr $(PROFILE) \>= 2), 1)
      CFLAGS += -fno-inline
    endif
  endif

  ifeq ($(shell expr $(DEBUG) \>= 3), 1)
    ifeq ($(shell expr $(PROFILE) \>= 2), 1)
      CFLAGS += -O0
    endif
  endif
else
  CFLAGS += -DNDEBUG
endif

ifdef MSG_LEVEL
  CFLAGS += -DMSG_LEVEL=$(MSG_LEVEL)
endif

ifneq ($(BACKEND),posix)
  ifneq ($(FREETYPE_CONFIG),)
    CFLAGS += $(shell $(FREETYPE_CONFIG) --cflags)
    ifeq ($(shell expr $(STATIC) \>= 1), 1)
      # since static is not supported by slightly old freetype versions
      FTF := $(shell $(FREETYPE_CONFIG) --libs --static)
      ifneq ($(FTF),)
        LDFLAGS += $(subst -lm ,,$(FTF))
      else
        LDFLAGS += $(shell $(FREETYPE_CONFIG) --libs)
      endif
    else
      LDFLAGS   += $(shell $(FREETYPE_CONFIG) --libs)
    endif
  else
    LDFLAGS += -lfreetype
    ifeq ($(OSTYPE),mingw)
      LDFLAGS += -lpng -lharfbuzz
    endif
  endif
  
  ifeq ($(OSTYPE),mingw)
    LDFLAGS += -lfreetype
  endif

  ifdef USE_FONTCONFIG
    ifeq ($(shell expr $(USE_FONTCONFIG) \>= 1), 1)
      sdfsfsd := $(shell echo error)
      CFLAGS  += -DUSE_FONTCONFIG
      CFLAGS  += $(shell $(FONTCONFIG_CONFIG) --cflags)
      LDFLAGS += $(shell $(FONTCONFIG_CONFIG) --libs)
    endif
  endif
endif

ifdef USE_UPNP
  ifeq ($(shell expr $(USE_UPNP) \>= 1), 1)
    CFLAGS      += -DUSE_UPNP
    LDFLAGS     += -lminiupnpc
    ifeq ($(OSTYPE),mingw)
      ifeq ($(shell expr $(STATIC) \>= 1), 1)
        LDFLAGS += -Wl,-Bdynamic
      endif
      LDFLAGS   += -liphlpapi
      ifeq ($(shell expr $(STATIC) \>= 1), 1)
        LDFLAGS += -Wl,-Bstatic
      endif
    endif
  endif
endif

ifdef USE_ZSTD
  ifeq ($(shell expr $(USE_ZSTD) \>= 1), 1)
    CFLAGS  += -DUSE_ZSTD
    LDFLAGS += -lzstd
    SOURCES += src/simutrans/io/rdwr/zstd_file_rdwr_stream.cc
  endif
endif

ifdef USE_FLUIDSYNTH_MIDI
  ifeq ($(shell expr $(USE_FLUIDSYNTH_MIDI) \>= 1), 1)
    CFLAGS  += -DUSE_FLUIDSYNTH_MIDI
    SOURCES += src/simutrans/music/fluidsynth.cc
    SOURCES += src/simutrans/gui/loadsoundfont_frame.cc
    LDFLAGS += $(DYNAMICSTART)-lfluidsynth $(DYNAMICEND)
    ifeq ($(OSTYPE),mingw)
      # fluidsynth.pc doesn't properly list dependant libraries, unable to use pkg-config. Manually listed below. Only valid for fluidsynth built with options: "-DBUILD_SHARED_LIBS=0 -Denable-aufile=0 -Denable-dbus=0 -Denable-ipv6=0 -Denable-jack=0 -Denable-ladspa=0 -Denable-midishare=0 -Denable-opensles=0 -Denable-oboe=0 -Denable-oss=0 -Denable-readline=0 -Denable-winmidi=0 -Denable-waveout=0 -Denable-libsndfile=0 -Denable-network=0 -Denable-pulseaudio=0 Denable-dsound=1 -Denable-sdl2=0"
      LDFLAGS += -lglib-2.0 -lintl -liconv -ldsound -lole32
    else
    endif
  endif
else
  USE_FLUIDSYNTH_MIDI := 0
endif

ifdef PROFILE
  ifeq ($(shell expr $(PROFILE) \>= 1), 1)
    CFLAGS   += -pg -DPROFILE
    ifeq ($(shell expr $(PROFILE) \>= 2), 1)
      CFLAGS += -fno-inline

      ifeq ($(findstring clang, $(CXX)),)
        CFLAGS += -fno-schedule-insns
      endif
    endif
    LDFLAGS  += -pg
  endif
endif

ifdef WITH_REVISION
  ifeq ($(shell expr $(WITH_REVISION) \>= 1), 1)
    ifeq ($(shell expr $(WITH_REVISION) \>= 2), 1)
      REV := $(WITH_REVISION)
    else
      REV := $(shell tools/get_revision.sh)
      $(info Revision is $(REV))
    endif
  endif
endif

ifneq ($(REV),)
  CFLAGS  += -DREVISION=$(REV)
  DUMMY := $(shell rm -f src/simutrans/revision.h)
else
  ifeq ("$(wildcard src/simutrans/revision.h)","")
    DUMMY := $(shell printf '#define REVISION' > src/simutrans/revision.h)
  endif
endif


ifneq ($(GIT_HASH),)
  GIT_HASH := $(shell git rev-parse --short=7 HEAD)
  ifeq ($(.SHELLSTATUS),0)
    $(info Git hash is 0x$(GIT_HASH))
    CFLAGS  += -DGIT_HASH=0x$(GIT_HASH)
  endif
endif


CFLAGS   += -Wall -Wextra -Wcast-qual -Wpointer-arith -Wcast-align $(FLAGS)
CCFLAGS  += -ansi -Wstrict-prototypes -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64


# sources (in alphabetic order)
SOURCES += src/simutrans/builder/brueckenbauer.cc
SOURCES += src/simutrans/builder/fabrikbauer.cc
SOURCES += src/simutrans/builder/goods_manager.cc
SOURCES += src/simutrans/builder/hausbauer.cc
SOURCES += src/simutrans/builder/tree_builder.cc
SOURCES += src/simutrans/builder/tunnelbauer.cc
SOURCES += src/simutrans/builder/vehikelbauer.cc
SOURCES += src/simutrans/builder/wegbauer.cc
SOURCES += src/simutrans/dataobj/crossing_logic.cc
SOURCES += src/simutrans/dataobj/environment.cc
SOURCES += src/simutrans/dataobj/freelist.cc
SOURCES += src/simutrans/dataobj/gameinfo.cc
SOURCES += src/simutrans/dataobj/height_map_loader.cc
SOURCES += src/simutrans/dataobj/koord.cc
SOURCES += src/simutrans/dataobj/koord3d.cc
SOURCES += src/simutrans/dataobj/loadsave.cc
SOURCES += src/simutrans/dataobj/marker.cc
SOURCES += src/simutrans/dataobj/objlist.cc
SOURCES += src/simutrans/dataobj/pakset_manager.cc
SOURCES += src/simutrans/dataobj/pakset_downloader.cc
SOURCES += src/simutrans/dataobj/powernet.cc
SOURCES += src/simutrans/dataobj/records.cc
SOURCES += src/simutrans/dataobj/rect.cc
SOURCES += src/simutrans/dataobj/ribi.cc
SOURCES += src/simutrans/dataobj/route.cc
SOURCES += src/simutrans/dataobj/scenario.cc
SOURCES += src/simutrans/dataobj/schedule.cc
SOURCES += src/simutrans/dataobj/settings.cc
SOURCES += src/simutrans/dataobj/sve_cache.cc
SOURCES += src/simutrans/dataobj/tabfile.cc
SOURCES += src/simutrans/dataobj/translator.cc
SOURCES += src/simutrans/descriptor/bridge_desc.cc
SOURCES += src/simutrans/descriptor/building_desc.cc
SOURCES += src/simutrans/descriptor/factory_desc.cc
SOURCES += src/simutrans/descriptor/goods_desc.cc
SOURCES += src/simutrans/descriptor/ground_desc.cc
SOURCES += src/simutrans/descriptor/image.cc
SOURCES += src/simutrans/descriptor/obj_base_desc.cc
SOURCES += src/simutrans/descriptor/reader/bridge_reader.cc
SOURCES += src/simutrans/descriptor/reader/building_reader.cc
SOURCES += src/simutrans/descriptor/reader/citycar_reader.cc
SOURCES += src/simutrans/descriptor/reader/crossing_reader.cc
SOURCES += src/simutrans/descriptor/reader/factory_reader.cc
SOURCES += src/simutrans/descriptor/reader/good_reader.cc
SOURCES += src/simutrans/descriptor/reader/ground_reader.cc
SOURCES += src/simutrans/descriptor/reader/groundobj_reader.cc
SOURCES += src/simutrans/descriptor/reader/image_reader.cc
SOURCES += src/simutrans/descriptor/reader/imagelist2d_reader.cc
SOURCES += src/simutrans/descriptor/reader/imagelist_reader.cc
SOURCES += src/simutrans/descriptor/reader/obj_reader.cc
SOURCES += src/simutrans/descriptor/reader/pedestrian_reader.cc
SOURCES += src/simutrans/descriptor/reader/roadsign_reader.cc
SOURCES += src/simutrans/descriptor/reader/root_reader.cc
SOURCES += src/simutrans/descriptor/reader/sim_reader.cc
SOURCES += src/simutrans/descriptor/reader/skin_reader.cc
SOURCES += src/simutrans/descriptor/reader/sound_reader.cc
SOURCES += src/simutrans/descriptor/reader/text_reader.cc
SOURCES += src/simutrans/descriptor/reader/tree_reader.cc
SOURCES += src/simutrans/descriptor/reader/tunnel_reader.cc
SOURCES += src/simutrans/descriptor/reader/vehicle_reader.cc
SOURCES += src/simutrans/descriptor/reader/way_obj_reader.cc
SOURCES += src/simutrans/descriptor/reader/way_reader.cc
SOURCES += src/simutrans/descriptor/reader/xref_reader.cc
SOURCES += src/simutrans/descriptor/sound_desc.cc
SOURCES += src/simutrans/descriptor/tunnel_desc.cc
SOURCES += src/simutrans/descriptor/vehicle_desc.cc
SOURCES += src/simutrans/descriptor/way_desc.cc
SOURCES += src/simutrans/display/font.cc
SOURCES += src/simutrans/display/simgraph$(COLOUR_DEPTH).cc
SOURCES += src/simutrans/display/simview.cc
SOURCES += src/simutrans/display/viewport.cc
SOURCES += src/simutrans/freight_list_sorter.cc
SOURCES += src/simutrans/ground/boden.cc
SOURCES += src/simutrans/ground/brueckenboden.cc
SOURCES += src/simutrans/ground/fundament.cc
SOURCES += src/simutrans/ground/grund.cc
SOURCES += src/simutrans/ground/monorailboden.cc
SOURCES += src/simutrans/ground/tunnelboden.cc
SOURCES += src/simutrans/ground/wasser.cc
SOURCES += src/simutrans/gui/components/gui_aligned_container.cc
SOURCES += src/simutrans/gui/components/gui_building.cc
SOURCES += src/simutrans/gui/components/gui_button.cc
SOURCES += src/simutrans/gui/components/gui_button_to_chart.cc
SOURCES += src/simutrans/gui/components/gui_chart.cc
