=== debian/changelog ===
simutrans (124.3-2build1) resolute; urgency=medium

  * Rebuild against latest miniupnpc

 -- Jeremy Bícha <jbicha@ubuntu.com>  Wed, 29 Oct 2025 15:49:34 -0400

simutrans (124.3-2) unstable; urgency=medium

  * Team Upload
  * Clean better (Closes: #1045991)
  * Remove obsolete dependency on quilt
  * Reformat d/control with debputy

 -- Alexandre Detiste <tchet@debian.org>  Mon, 17 Mar 2025 17:01:17 +0100

simutrans (124.3-1) unstable; urgency=medium

  * Team Upload

  [ Jörg Frings-Fürst ]
  * New debian/patches/0115-fix_miniupnpc.patch (Closes: #1076693):
    - Fix FTBFS with miniupnpc 2.2.8.
      Thanks to Yangfl <mmyangfl@gmail.com>.
  * debian/copyright:
    - Add year 2024 to myself.
  * Declare compliance with Debian Policy 4.7.0 (No changes needed).
  * debian/rules:
    + Fix FTCBFS: uses build architecture build tools (Closes: #1038715).
      Thanks to Helmut Grohne <helmut@subdivi.de>.
  * Add debian/salsa-ci.yml to enable some tests.
  *  Datei .gitlab-ci.yml aktualisieren

  [ Patrice Duroux ]
  * d/watch: use github
  * New upstream version 124.3 (Closes: #1087201)
  * d/copyright: use https, bump year, refresh file paths
  * d/control: use https in homepage
  * d/simutrans.xpm: remove (upstream provides svg)
  * d/control: add libfontconfig-dev and pkgconf to BD
  * d/rules: use cmake
  * d/*.dirs: remove all and refresh d/*.install
  * d/translations: removed (upstream have?)
  * d/patches: clean up

 -- Alexandre Detiste <tchet@debian.org>  Fri, 31 Jan 2025 16:00:56 +0100
