=== debian/control ===
Source: simutrans
Section: games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Clint Adams <clint@debian.org>,
 Jörg Frings-Fürst <debian@jff.email>,
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 libbz2-dev,
 libfluidsynth-dev,
 libfontconfig-dev,
 libfreetype-dev,
 libminiupnpc-dev,
 libpng-dev,
 libsdl2-dev,
 libsdl2-mixer-dev,
 libzstd-dev,
 pkgconf,
 zlib1g-dev,
Standards-Version: 4.7.0
Rules-Requires-Root: no
Homepage: https://www.simutrans.com/
Vcs-Git: https://salsa.debian.org/games-team/simutrans.git
Vcs-Browser: https://salsa.debian.org/games-team/simutrans
X-Style: black

Package: simutrans
Architecture: any
Depends:
 simutrans-data (= ${source:Version}),
 simutrans-pak64 (>= 121.0),
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 freepats,
Description: transportation simulator
 Simutrans is a free transportation simulator: The player operates a
 transportation company and has to transport goods and passengers between
 factories and different cities.

Package: simutrans-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: transportation simulator (base data)
 Simutrans is a free transportation simulator: The player operates a
 transportation company and has to transport goods and passengers between
 factories and different cities.
 .
 This package contains the base data.

Package: simutrans-makeobj
Architecture: any
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: data file compiler for Simutrans
 Simutrans is a free transportation simulator: The player operates a
 transportation company and has to transport goods and passengers between
 factories and different cities.
 .
 This package contains the makeobj program needed to integrate new objects
 in Simutrans.
