=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# debian/rules file for simutrans

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
#export VERBOSE  = 1

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
TODAY=$(shell env LC_TIME=C.utf8 date --utc --date=@${SOURCE_DATE_EPOCH} +"%Y-%m-%d")
SIMUTRANS_REVISION=386

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_BINDIR=/usr/games -DSIMUTRANS_USE_REVISION=${SIMUTRANS_REVISION} -DUSE_GAMES_DATADIR=1
	sed -e "s/@TODAY@/${TODAY}/g" -e "s/@SIMUTRANS_WC_REVISION@/${SIMUTRANS_REVISION}/g" -e "s/@ver_major@.@ver_minor@.@ver_patch@@nightly_suffix@/${DEB_VERSION_UPSTREAM}/g" $(CURDIR)/src/linux/com.simutrans.Simutrans.metainfo.xml.in > $(CURDIR)/src/linux/com.simutrans.Simutrans.metainfo.xml

override_dh_auto_build:
	dh_auto_build
	dh_auto_build -- makeobj
	#dh_auto_build -- nettool

override_dh_auto_test:

override_dh_installchangelogs:
	dh_installchangelogs simutrans/history.txt

update-translations:
	dh_testdir
	wget --post-data "version=0&choice=all&submit=Export!" --delete-after "http://simutrans-germany.com/translator/script/main.php?page=wrap"
	wget -N http://simutrans-germany.com/translator/data/tab/language_pack-Base+texts.zip
	unzip -o -d debian/translations language_pack-Base+texts.zip "*.tab"
	$(RM) language_pack-Base+texts.zip
