=== debian/watch ===
version=4
https://github.com/simutrans/@PACKAGE@/tags .*/v?(\d.*)@ARCHIVE_EXT@
